#include <stm32l1xx.h>
#include <stm32l1xx_rcc.h>
#include <stm32l1xx_gpio.h>

void EXTI0_IRQHandler (void)
{
	GPIOB->ODR |= (GPIOA->IDR & GPIO_Pin_0)*GPIO_Pin_6;
	GPIOB->ODR &= ~(~GPIOA->IDR & GPIO_Pin_0)*GPIO_Pin_6;

	EXTI->PR &= ~EXTI_PR_PR0;
}

int main()
{
	RCC->AHBENR |= RCC_AHBENR_GPIOBEN | RCC_AHBENR_GPIOAEN ;

	GPIOB->MODER |= GPIO_MODER_MODER7_0;
	GPIOB->OTYPER &= ~GPIO_OTYPER_OT_7;
	GPIOB->PUPDR &= ~GPIO_PUPDR_PUPDR7;
	GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR7;

	GPIOB->MODER |= GPIO_MODER_MODER6_0;
	GPIOB->OTYPER &= ~GPIO_OTYPER_OT_6;
	GPIOB->PUPDR &= ~GPIO_PUPDR_PUPDR6;
	GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR6;

	GPIOA->MODER &= ~GPIO_MODER_MODER0;
	GPIOA->PUPDR &= ~GPIO_PUPDR_PUPDR0_1;
	GPIOA->PUPDR |= GPIO_PUPDR_PUPDR0_0;

	__enable_irq();

	NVIC_SetPriority(EXTI0_IRQn, 1);
	NVIC_EnableIRQ(EXTI0_IRQn);

	EXTI->IMR |= EXTI_IMR_MR0;		//Разрешение источников внешних прерываний
	EXTI->EMR |= EXTI_EMR_MR0 ;		//Разрешение возобновления при внешних событиях

	EXTI->FTSR = EXTI_RTSR_TR0 ;	//Выбор падающего фронта в качестве источника запуска
	EXTI->RTSR = EXTI_FTSR_TR0;		//Выбор нарастающего фронта в качестве источника запуска

	GPIOB->BSRRL = GPIO_Pin_7;

	while (1) {
	}

	return 0;
}

